//	^uRg[+EBhEnh̎擾
//	Visual C++ 2013 32/64bit

#include <windows.h>
#include <commctrl.h> 
#include <stdio.h>
#include <tchar.h>
#include "resource.h"

#define GET_WIN	1	//	tabctl.cppɒǉ

#ifdef GET_WIN	//	tabctl.cppɒǉ
void GetWindows2Save(HWND hWnd, int level = 0);
void GetWindow2Save(HWND hWnd);
void EnumWindow2Save(void);
void EnumChildWindow2Save(HWND hWnd);
void FindWindow2Save(void);
void FindWindowEx2Save(HWND hParent);
#endif

//	_CAO{bNXvV[W[
LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
//	^uRg[0y[W
LRESULT CALLBACK Page0Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
//	^uRg[1y[W
LRESULT CALLBACK Page1Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

HINSTANCE hInst;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
                   TCHAR* lpszCmdLine, int nCmdShow){
	::hInst = hInstance;

	DialogBox(hInstance, TEXT("TAB_DLG"), 0, (DLGPROC)DlgProc1);
    return (int)0;
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	static HWND hTab;
	static HWND hPage0;
	static HWND hPage1;
	RECT rc;
	TCITEM tc_item;
    switch (msg) {
        case WM_INITDIALOG:
			hTab = GetDlgItem(hDlg, IDC_TABCNTRL);
			tc_item.mask = TCIF_TEXT;
			tc_item.pszText = _TEXT("O");
			TabCtrl_InsertItem(hTab, 0, &tc_item);

			tc_item.pszText = TEXT("");
			TabCtrl_InsertItem(hTab, 1, &tc_item);
			hPage0 = CreateDialog(::hInst, _TEXT("DLG1"), hDlg, (DLGPROC)Page0Proc);
			hPage1 = CreateDialog(::hInst, _TEXT("DLG2"), hDlg, (DLGPROC)Page1Proc);
			ShowWindow(hPage0, SW_SHOW);
			ShowWindow(hPage1, SW_HIDE);
			GetClientRect(hDlg, &rc);
			SendMessage(hDlg, WM_SIZE, 0, MAKELPARAM(rc.right, rc.bottom));
			return TRUE;
		case WM_SIZE:{
			POINT dlg_pt;
			POINT tab_pt;
			dlg_pt.x = dlg_pt.y = 0;
			ClientToScreen(hDlg, &dlg_pt);
			tab_pt.x = tab_pt.y = 0;
			ClientToScreen(hTab, &tab_pt);

			GetClientRect(hTab, &rc);
			TabCtrl_AdjustRect(hTab, FALSE, &rc);

			int dx = tab_pt.x - dlg_pt.x;
			int dy = tab_pt.y - dlg_pt.y;
			MoveWindow(hPage0, rc.left+dx, rc.top+dy, rc.right - rc.left, rc.bottom - rc.top , TRUE);
			MoveWindow(hPage1, rc.left+dx, rc.top+dy, rc.right - rc.left, rc.bottom - rc.top, TRUE);
			break;
		}
		case WM_NOTIFY:
			switch (((NMHDR *)lParam)->code){
				case TCN_SELCHANGE:{	//	^u̐؂ւ
					int num=TabCtrl_GetCurSel(hTab);
					if (num == 0){
						ShowWindow(hPage0, SW_SHOW);
						ShowWindow(hPage1, SW_HIDE);
					}
					else{
						ShowWindow(hPage0, SW_HIDE);
						ShowWindow(hPage1, SW_SHOW);
					}
					break;
				}
			}
			return FALSE;
		case WM_COMMAND:
            switch (LOWORD(wParam)) {
				case IDOK:{
#ifdef GET_WIN	//	tabctl.cppɒǉ
					GetWindow2Save(hDlg);
					GetWindows2Save(hDlg);
					EnumChildWindow2Save(hDlg);
					EnumWindow2Save();
					FindWindow2Save();
					FindWindowEx2Save(hDlg);
#endif
					EndDialog(hDlg, TRUE);
					return TRUE;
				}
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
					return FALSE;
				default:
					return FALSE;
			}
			default:
				return FALSE;
	}
	return TRUE;
}

//	^uRg[0y[W

LRESULT CALLBACK Page0Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	TCHAR buf[32];
	switch (msg) {
	case WM_INITDIALOG:
		SetWindowText(GetDlgItem(hDlg, IDC_EDIT1), _TEXT("RcY"));
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_EDIT1:
			if (HIWORD(wParam) == EN_UPDATE){	//	GfBbg{bNXύXꂽꍇ
				GetDlgItemText(hDlg, IDC_EDIT1, (TCHAR*)buf, sizeof(buf) / sizeof(TCHAR));
				SetWindowText(GetDlgItem(GetParent(hDlg), IDC_LABEL1), buf);
			}
			break;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

//	^uRg[1y[W

LRESULT CALLBACK Page1Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	switch (msg) {
	case WM_INITDIALOG:
		SendMessage(GetDlgItem(hDlg, IDC_RADIOBUTTON101), BM_SETCHECK, BST_CHECKED, 0);
		SendMessage(GetDlgItem(hDlg, IDC_RADIOBUTTON111), BM_SETCHECK, BST_CHECKED, 0);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_RADIOBUTTON101:
			if (HIWORD(wParam) == BN_CLICKED){
				SetWindowText(GetDlgItem(GetParent(hDlg), IDC_LABEL103), _TEXT("j"));
			}
			return FALSE;
		case IDC_RADIOBUTTON102:
			if (HIWORD(wParam) == BN_CLICKED){
				SetWindowText(GetDlgItem(GetParent(hDlg), IDC_LABEL103), _TEXT(""));
			}
			return FALSE;
		case IDC_RADIOBUTTON111:
			if (HIWORD(wParam) == BN_CLICKED){
				SetWindowText(GetDlgItem(GetParent(hDlg), IDC_LABEL113), _TEXT("q"));
			}
			return FALSE;
		case IDC_RADIOBUTTON112:
			if (HIWORD(wParam) == BN_CLICKED){
				SetWindowText(GetDlgItem(GetParent(hDlg), IDC_LABEL113), _TEXT("l"));
			}
			return FALSE;

		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

#ifdef GET_WIN	//	tabctl.cppɒǉ

void GetWindow2Save(HWND hWnd){
	FILE* fp;
	_tfopen_s(&fp, _TEXT("GetWindow.txt"), _TEXT("w,ccs=UNICODE"));
	HWND hChild = GetWindow(hWnd, GW_CHILD);
	while (hChild){
		TCHAR title[128];
		TCHAR className[128];
		GetWindowText(hChild, title, sizeof(title) / sizeof(TCHAR));//EChE̕擾
		GetClassName(hChild, className, sizeof(className) / sizeof(TCHAR));
#ifdef _WIN64
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.16I64x %0.16I64x\n"), title, className, (UINT64)hChild, (UINT64)hWnd);
#else
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.8x %0.8x\n"), title, className, (DWORD)hChild, (DWORD)hWnd);
#endif
		hChild = GetWindow(hChild, GW_HWNDNEXT);
	}
	fclose(fp);
}

void GetWindows2Save(HWND hWnd, int level){
	static FILE* fp = 0;
	if (level == 0){
		_tfopen_s(&fp, _TEXT("GetWindows.txt"), _TEXT("w,ccs=UNICODE"));
	}
	HWND hChild = GetWindow(hWnd, GW_CHILD);
	while (hChild){
		TCHAR title[128];
		TCHAR className[128];
		GetWindowText(hChild, title, sizeof(title) / sizeof(TCHAR));//EChE̕擾
		GetClassName(hChild, className, sizeof(className) / sizeof(TCHAR));
		for (int n = 0; n<level; n++){
			_ftprintf(fp, _TEXT("\t"));
		}
#ifdef _WIN64
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.16I64x %0.16I64x\n"), title, className, (UINT64)hChild, (UINT64)hWnd);
#else
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.8x %0.8x\n"), title, className, (DWORD)hChild, (DWORD)hWnd);
#endif
		GetWindows2Save(hChild, level + 1);
		hChild = GetWindow(hChild, GW_HWNDNEXT);
	}
	if (level == 0){
		fclose(fp);
	}
}

BOOL CALLBACK EnumWndProc(HWND hWnd, LPARAM lParam){
	FILE* fp = (FILE*)lParam;
	TCHAR title[128];
	TCHAR className[128];
	GetWindowText(hWnd, title, sizeof(title) / sizeof(TCHAR));
	GetClassName(hWnd, className, sizeof(className) / sizeof(TCHAR));
#ifdef _WIN64
	_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.16I64x\n"), title, className, (UINT64)hWnd);
#else
	_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.8x\n"), title, className, (DWORD)hWnd);
#endif
	return true;
}

void EnumChildWindow2Save(HWND hWnd){
	FILE* fp;
	_tfopen_s(&fp, _TEXT("EnumChildWindow.txt"), _TEXT("w,ccs=UNICODE"));
	EnumChildWindows(hWnd, EnumWndProc, (LPARAM)fp);
	fclose(fp);
}

void EnumWindow2Save(void){
	FILE* fp;
	_tfopen_s(&fp, _TEXT("EnumWindow.txt"), _TEXT("w,ccs=UNICODE"));
	EnumWindows(EnumWndProc, (LPARAM)fp);
	fclose(fp);
}

void FindWindow2Save(void){
	FILE* fp;
	_tfopen_s(&fp, _TEXT("FindWindow.txt"), _TEXT("w,ccs=UNICODE"));
	{
		HWND hWnd = FindWindow(_TEXT("SystemTray_Main"), NULL);
		TCHAR title[128];
		TCHAR className[128];
		GetWindowText(hWnd, title, sizeof(title) / sizeof(TCHAR));//EChE̕擾
		GetClassName(hWnd, className, sizeof(className) / sizeof(TCHAR));
#ifdef _WIN64
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.16I64x\n"), title, className, (UINT64)hWnd);
#else
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.8x\n"), title, className, (DWORD)hWnd);
#endif
	}
	fclose(fp);
}

void FindWindowEx2Save(HWND hParent){
	FILE* fp;

	_tfopen_s(&fp, _TEXT("FindWindowEx.txt"), _TEXT("w,ccs=UNICODE"));
	HWND hWnd = 0;
	while (hWnd = FindWindowEx(hParent, hWnd, _TEXT("Button"), NULL)){
		TCHAR title[128];
		TCHAR className[128];
		GetWindowText(hWnd, title, sizeof(title) / sizeof(TCHAR));//EChE̕擾
		GetClassName(hWnd, className, sizeof(className) / sizeof(TCHAR));
#ifdef _WIN64
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.16I64x\n"), title, className, (UINT64)hWnd);
#else
		_ftprintf(fp, _TEXT("\"%s\" \"%s\" %0.8x\n"), title, className, (DWORD)hWnd);
#endif
	}
	fclose(fp);
}

#endif
